VERSION 2.00
Begin Form Panel 
   Caption         =   "Chemco Plant Control Panel"
   ClientHeight    =   1185
   ClientLeft      =   75
   ClientTop       =   5385
   ClientWidth     =   9420
   Height          =   1590
   Left            =   15
   LinkTopic       =   "Form1"
   ScaleHeight     =   1185
   ScaleWidth      =   9420
   Top             =   5040
   Width           =   9540
   Begin HScrollBar RS3 
      Height          =   255
      Left            =   1800
      Max             =   99
      TabIndex        =   15
      Top             =   840
      Width           =   3495
   End
   Begin HScrollBar RS2 
      Height          =   255
      LargeChange     =   10
      Left            =   1800
      Max             =   99
      TabIndex        =   14
      Top             =   480
      Width           =   3495
   End
   Begin HScrollBar RS1 
      Height          =   255
      LargeChange     =   10
      Left            =   1800
      Max             =   99
      TabIndex        =   13
      Top             =   120
      Width           =   3495
   End
   Begin CommandButton Begin 
      Caption         =   "Reset"
      Enabled         =   0   'False
      Height          =   375
      Left            =   7680
      TabIndex        =   9
      Top             =   120
      Width           =   1455
   End
   Begin CommandButton Instr 
      Caption         =   "Instructions"
      Height          =   375
      Left            =   7680
      TabIndex        =   8
      Top             =   600
      Width           =   1455
   End
   Begin CommandButton Stop 
      Caption         =   "Stop"
      Enabled         =   0   'False
      Height          =   375
      Left            =   6600
      TabIndex        =   7
      Top             =   600
      Width           =   855
   End
   Begin CommandButton Start 
      Caption         =   "Go"
      Height          =   375
      Left            =   6600
      TabIndex        =   6
      Top             =   120
      Width           =   855
   End
   Begin TextBox Rate3 
      Height          =   285
      Left            =   5280
      TabIndex        =   5
      Text            =   "0"
      Top             =   840
      Width           =   375
   End
   Begin TextBox Rate2 
      Height          =   285
      Left            =   5280
      TabIndex        =   4
      Text            =   "0"
      Top             =   480
      Width           =   375
   End
   Begin TextBox Rate1 
      Height          =   285
      Left            =   5280
      TabIndex        =   3
      Text            =   "0"
      Top             =   120
      Width           =   375
   End
   Begin Label Vol 
      Caption         =   "m3/h"
      Height          =   255
      Index           =   2
      Left            =   5760
      TabIndex        =   12
      Top             =   840
      Width           =   495
   End
   Begin Label Vol 
      Caption         =   "m3/h"
      Height          =   255
      Index           =   1
      Left            =   5760
      TabIndex        =   11
      Top             =   480
      Width           =   495
   End
   Begin Label Vol 
      Caption         =   "m3/h"
      Height          =   255
      Index           =   0
      Left            =   5760
      TabIndex        =   10
      Top             =   120
      Width           =   495
   End
   Begin Label T3 
      Caption         =   "Mixer to Tank 3"
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   840
      Width           =   1455
   End
   Begin Label T2 
      Caption         =   "Tank 2 to Mixer"
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   480
      Width           =   1455
   End
   Begin Label T1 
      Caption         =   "Tank 1 to Mixer"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1455
   End
End

Option Explicit

Dim WitnessObject As Object

Dim WitnessSystem As String

Dim WitnessShell As Integer

Dim FlowRate As Double

Dim State As Integer

Sub Begin_Click ()
    Dim CRNL As String
    CRNL = Chr$(13) + Chr$(10)
    Panel.Start.Enabled = True
    Panel.Stop.Enabled = False
    Panel.Begin.Enabled = False
    Panel.Instr.Enabled = True
    WitnessObject.WCL ("Begin")
    WitnessObject.Action ("USER(1)=" + Rate1.Text)
    WitnessObject.Action ("USER(2)=" + Rate2.Text)
    WitnessObject.Action ("USER3=" + Rate3.Text)
    WitnessObject.Action ("CloseBox")
    WitnessObject.EndOLE
End Sub

Sub Form_Load ()
On Error GoTo WitnessNotCurrentlyLoaded
Set WitnessObject = GetObject(, "Witness.WCL")
GoTo WitnessLoaded
WitnessNotCurrentlyLoaded:
Resume LoadWitness
LoadWitness:
On Error GoTo WitnessFailedToLoad
WitnessSystem = Environ$("WITSYS")
If WitnessSystem = "" Then
   MsgBox "WITNESS has not been loaded successfully.  Ensure that WITSYS is set correctly.  Application will terminate.", 16, "WITNESS"
   End
Else
   WitnessShell = Shell(WitnessSystem & "\WITNESS.EXE " & WitnessSystem & "\DEMO\CHEMCO.MOD", 1)
   Set WitnessObject = GetObject(, "Witness.WCL")
   While WitnessObject.ModelStatus < 1 Or WitnessObject.ModelStatus > 2
      DoEvents
   Wend
End If
WitnessLoaded:
DoEvents
Exit Sub
WitnessFailedToLoad:
MsgBox "WITNESS has not been loaded successfully.  Application will terminate.", 16, "WITNESS"
End
End Sub

Sub HScroll2_Change ()
    FlowRate = RS3.Value
    If FlowRate < 0 Or FlowRate > 99 Then
      MsgBox "Flow Rate must be between 0 and 99 m3/h", 48, "WITNESS"
    Else
      State = WitnessObject.ModelStatus
      If State = 1 Then
        WitnessObject.Stop
      End If
      WitnessObject.Action ("USER3=" + CStr(RS3.Value))
      Rate3.Text = CStr(RS3.Value)
      If State = 1 Then
        WitnessObject.Run
      End If
    End If
End Sub

Sub Instr_Click ()
Load Info
Info.Show
End Sub

Sub Rate1_Change ()
    FlowRate = Val(Rate1.Text)
    If FlowRate < 0 Or FlowRate > 99 Then
      MsgBox "Flow Rate must be between 0 and 99 m3/h", 48, "WITNESS"
    Else
      RS1.Value = FlowRate
    End If
End Sub

Sub Rate2_Change ()
    FlowRate = Val(Rate2.Text)
    If FlowRate < 0 Or FlowRate > 99 Then
      MsgBox "Flow Rate must be between 0 and 99 m3/h", 48, "WITNESS"
    Else
      RS2.Value = FlowRate
    End If
End Sub

Sub Rate3_Change ()
    FlowRate = Val(Rate3.Text)
    If FlowRate < 0 Or FlowRate > 99 Then
      MsgBox "Flow Rate must be between 0 and 99 m3/h", 48, "WITNESS"
    Else
      RS3.Value = FlowRate
    End If
End Sub

Sub RS1_Change ()
    FlowRate = RS1.Value
    If FlowRate < 0 Or FlowRate > 99 Then
      MsgBox "Flow Rate must be between 0 and 99 m3/h", 48, "WITNESS"
    Else
      State = WitnessObject.ModelStatus
      If State = 1 Then
        WitnessObject.Stop
        While WitnessObject.ModelStatus = 1
          DoEvents
        Wend
      End If
      WitnessObject.Action ("USER(1)=" + CStr(RS1.Value))
      If State = 1 Then
        WitnessObject.Run
      End If
      Rate1.Text = CStr(RS1.Value)
    End If
End Sub

Sub RS2_Change ()
    FlowRate = RS2.Value
    If FlowRate < 0 Or FlowRate > 99 Then
      MsgBox "Flow Rate must be between 0 and 99 m3/h", 48, "WITNESS"
    Else
      State = WitnessObject.ModelStatus
      If State = 1 Then
        WitnessObject.Stop
        While WitnessObject.ModelStatus = 1
          DoEvents
        Wend
      End If
      WitnessObject.Action ("USER(2)=" + CStr(RS2.Value))
      If State = 1 Then
        WitnessObject.Run
      End If
      Rate2.Text = CStr(RS2.Value)
    End If
End Sub

Sub RS3_Change ()
    FlowRate = RS3.Value
    If FlowRate < 0 Or FlowRate > 99 Then
      MsgBox "Flow Rate must be between 0 and 99 m3/h", 48, "WITNESS"
    Else
      State = WitnessObject.ModelStatus
      If State = 1 Then
        WitnessObject.Stop
        While WitnessObject.ModelStatus = 1
          DoEvents
        Wend
      End If
      WitnessObject.Action ("USER3=" + CStr(RS3.Value))
      If State = 1 Then
        WitnessObject.Run
      End If
      Rate3.Text = CStr(RS3.Value)
    End If
End Sub

Sub Start_Click ()
    Panel.Start.Enabled = False
    Panel.Stop.Enabled = True
    Panel.Begin.Enabled = False
    Panel.Instr.Enabled = False
    WitnessObject.BeginOLE
    WitnessObject.Run
End Sub

Sub Stop_Click ()
    Panel.Start.Enabled = True
    Panel.Stop.Enabled = False
    Panel.Begin.Enabled = True
    Panel.Instr.Enabled = True
    WitnessObject.Stop
End Sub

