VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "Contact Center Model"
   ClientHeight    =   3180
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6870
   LinkTopic       =   "Form1"
   ScaleHeight     =   3180
   ScaleWidth      =   6870
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdExit 
      Caption         =   "Exit"
      Height          =   465
      Left            =   5250
      TabIndex        =   8
      Top             =   2520
      Width           =   1455
   End
   Begin VB.CommandButton cmdViewResults 
      Caption         =   "View Results"
      Height          =   465
      Left            =   3540
      TabIndex        =   7
      Top             =   2520
      Width           =   1455
   End
   Begin VB.CommandButton cmdRun 
      Caption         =   "Run Model"
      Height          =   465
      Left            =   1845
      TabIndex        =   6
      Top             =   2520
      Width           =   1455
   End
   Begin VB.CommandButton cmdEditInputs 
      Caption         =   "Edit Input Data"
      Height          =   465
      Left            =   135
      TabIndex        =   5
      Top             =   2520
      Width           =   1455
   End
   Begin VB.Frame Frame1 
      Caption         =   "Model Run Options"
      Height          =   1245
      Left            =   135
      TabIndex        =   1
      Top             =   1050
      Width           =   3360
      Begin VB.TextBox txtRunLength 
         Height          =   300
         Left            =   1995
         TabIndex        =   3
         Top             =   720
         Width           =   1110
      End
      Begin VB.CheckBox chkWitnessVisible 
         Caption         =   "View model running"
         Height          =   360
         Left            =   165
         TabIndex        =   2
         Top             =   300
         Width           =   1830
      End
      Begin VB.Label Label2 
         Caption         =   "Length of run (minutes):"
         Height          =   270
         Left            =   180
         TabIndex        =   4
         Top             =   735
         Width           =   1785
      End
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      Caption         =   "Contact Center Model"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   27.75
         Charset         =   0
         Weight          =   700
         Underline       =   -1  'True
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H008A026B&
      Height          =   720
      Left            =   30
      TabIndex        =   0
      Top             =   90
      Width           =   6735
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub cmdEditInputs_Click()
    On Error GoTo cmdEditInputs_Click_Err
        
    OpenSpreadsheet True
    
cmdEditInputs_Click_Exit:
    Exit Sub

cmdEditInputs_Click_Err:
    MsgBox Error$
    Resume Next
End Sub

Private Sub cmdRun_Click()
    On Error GoTo cmdRun_Click_Err

    Dim nRunLength As Integer
    
    nRunLength = GetRunLength()
    If nRunLength <> -1 Then
        RunWitnessModel nRunLength
    Else
        MsgBox "Invalid run length specified.", vbOKOnly + vbInformation
    End If
    
cmdRun_Click_Exit:
    Exit Sub

cmdRun_Click_Err:
    MsgBox Error$
    Resume Next
End Sub

Private Sub cmdViewResults_Click()
    On Error GoTo cmdViewResults_Click_Err
    
    OpenSpreadsheet True
    
cmdViewResults_Click_Exit:
    Exit Sub

cmdViewResults_Click_Err:
    MsgBox Error$
    Resume Next
End Sub


Private Sub cmdExit_Click()
    Unload Me
End Sub



Private Function GetRunLength() As Integer
    On Error GoTo GetRunLength_Err

    GetRunLength = -1
    
    'check that a value has been specified in the run length text box
    If txtRunLength <> "" Then
        'check that the value is numeric
        If IsNumeric(txtRunLength) Then
            'convert the string to an integer and return
            GetRunLength = CInt(txtRunLength)
        End If
    End If

GetRunLength_Exit:
    Exit Function

GetRunLength_Err:
    MsgBox Error$
    Resume Next
End Function
